/**
 * @file
 * Toc_js.
 */

(function ($) {
  'use strict';

  Drupal.behaviors.toc_js = {
    attach: function(context, settings) {

      $('.toc-js', context).each(function () {
        var nav = $(this).find('nav');
        var settings = {
          listType: '<ul/>',
          selectors: $(this).data('selectors') || 'h2, h3',
          container: $(this).data('container') || 'body',
          scrollToOffset: $(this).data('scroll-to-offset') || 0,
          prefix: $(this).data('prefix') || 'toc',
          letterCase: $(this).data('letter-case') || 'lowercase',
          highlightOnScroll: !!$(this).data('highlight-on-scroll'),
          highlightOffset: $(this).data('highlight-offset') || 100
        };

        if (!$(this).data('smooth-scrolling')) {
          settings.smoothScrolling = false;
        }

        nav.toc(settings);

        nav.find('ul').attr('role', 'menubar');
        nav.find('li').each(function () {
          $(this).attr('role', 'presentation');
        });
        nav.find('a').each(function () {
          $(this).attr('aria-label', $(this).text());
        });
      });

      $('.toc-js', context).each(function () {
        var n = $(this).find('li').length;
        if (!n) {
          $(this).hide();
        }
      });

    }
  };

  Drupal.theme.toc_js_back_to_top = function(id) {
    return '<span class="backtop-to-top" href="#"></span>';
  }

}(jQuery));
